﻿Option Strict On
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.BackgroundTransfer
Imports System.IO.IsolatedStorage
Imports System.Xml.Linq


Public Class ImageInfo
    Property absoluteUri As String
End Class
Partial Public Class AddBackGroundTransfer
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub AddBackGroundTransfer_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim xmldoc As XElement = XElement.Load("absoluteUri.xml")
        Dim myImageInfo As New List(Of ImageInfo)

        For Each result In From c In xmldoc.Descendants("ImageName") Select c
            myImageInfo.Add(New ImageInfo With {.absoluteUri = result.Value})
        Next
        ListBox1.ItemsSource = myImageInfo

        Dim isolate As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If isolate.DirectoryExists("/shared/transfers") = False Then
            isolate.CreateDirectory("/shared/transfers")
        End If
    End Sub

    Private Sub AddFile_Click(sender As Object, e As EventArgs)
        Dim myTransferFileName As String = DirectCast(sender, Button).Tag.ToString
        Dim myTransferUri As Uri = New Uri(myTransferFileName, UriKind.Absolute)
        Dim myTransferRequest As BackgroundTransferRequest = New BackgroundTransferRequest(myTransferUri)
        myTransferRequest.Method = "GET"
        Dim myDownloadFile As String = myTransferFileName.Substring(myTransferFileName.LastIndexOf("/") + 1)
        Dim myDownloadUri As Uri = New Uri("shared/transfers/" & myDownloadFile, UriKind.RelativeOrAbsolute)
        myTransferRequest.DownloadLocation = myDownloadUri
        'myTransferRequest.Tag = myDownloadFile

        FileName.Append(myDownloadFile).Append(",")
        If FileName.ToString.Contains(".wmv") And FileName.ToString.Contains(".png") Then
            MessageBox.Show("形式の異なるファイルが選択されました。リストボックス内のデータを全部消去してから選択しなおしてください。")
            Exit Sub
        End If
        'myTransferRequest.TransferPreferences = TransferPreferences.AllowCellular
        Try
            BackgroundTransferService.Add(myTransferRequest)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try
    End Sub

End Class
