﻿Option Strict On
Imports Microsoft.Phone.Controls
Imports System.Windows.Threading
Imports Microsoft.Phone.BackgroundTransfer
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim myTransferRequests As IEnumerable(Of BackgroundTransferRequest)
    Dim myTimer As New DispatcherTimer

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        myTimer.Interval = TimeSpan.FromMilliseconds(300)
        AddHandler myTimer.Tick, Sub()
                                     If myTransferRequests Is Nothing = True Then
                                         myTimer.Stop()
                                         Return
                                     Else

                                         For Each myTransfer In myTransferRequests
                                             If myTransfer.TransferStatus = TransferStatus.Transferring Or myTransfer.TransferStatus = TransferStatus.Waiting Then
                                                 ResetTransferListBox()
                                                 Return
                                             End If
                                         Next
                                     End If
                                     myTimer.Stop()
                                 End Sub
    End Sub

    Private Sub ResetTransferListBox()
        myTransferRequests = BackgroundTransferService.Requests
        If myTransferRequests.Count() > 0 Then
            TextBlock1.Visibility = Visibility.Collapsed
        Else
            TextBlock1.Visibility = Visibility.Visible
        End If
        TransferListBox.ItemsSource = myTransferRequests
       
    End Sub

    Private Sub RemoveTransferRequest(myTransferID As String)

        Dim myTransferRemove As BackgroundTransferRequest = BackgroundTransferService.Find(myTransferID)
        Try
            BackgroundTransferService.Remove(myTransferRemove)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try
    End Sub

    Private Sub RemoveButton_Click(sender As Object, e As EventArgs)
        Dim myTransferID As String = DirectCast(sender, Button).Tag.ToString
        RemoveTransferRequest(myTransferID)
        ResetTransferListBox()
    End Sub

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        If FileName.ToString.Contains(".wmv") Then
            TransferListBox.SetValue(ListBox.ItemTemplateProperty, Resources("ListBoxTemplate2"))
        Else
            TransferListBox.SetValue(ListBox.ItemTemplateProperty, Resources("ListBoxTemplate"))
        End If
        ResetTransferListBox()
        myTimer.Start()

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub AddData_Click(sender As Object, e As EventArgs)
        If FileName.ToString.Contains(".wmv") AndAlso TransferListBox.Items.Count > 0 Then
            MessageBox.Show("WMVが選択されたか、WMVが実行されました。WMVを削除してください")
            Exit Sub
        ElseIf FileName.ToString.Contains(".wmv") AndAlso TransferListBox.Items.Count = 0 Then
            FileName.Clear()
        ElseIf FileName.ToString.Contains(".wmv") AndAlso FileName.ToString.Contains(".png") AndAlso TransferListBox.Items.Count = 0 Then
            FileName.Clear()
        End If

        NavigationService.Navigate(New Uri("/AddBackGroundTransfer.xaml", UriKind.Relative))
    End Sub

    Private Sub RemoveAllData_Click(sender As Object, e As EventArgs)
        For Each myTransfer In BackgroundTransferService.Requests
            If myTransfer.TransferStatus = TransferStatus.Completed Then
                RemoveTransferRequest(myTransfer.RequestId)
            End If
        Next
        FileName.Clear()
        ResetTransferListBox()
    End Sub

    Private Sub browserButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles browserButton.Click
        NavigationService.Navigate(New Uri("/WebBrowser.xaml", UriKind.Relative))
    End Sub
End Class
